namespace Telerik.Examples.Reports
{
	using System;
	using System.Collections;
	using System.Collections.Generic;
	using System.Linq;
	using Telerik.Examples.Reports.Services;

	public partial class ProductReport : Telerik.Reporting.Report
	{
		private NorthwindEntityContext _dataContext;
		public NorthwindEntityContext DataContext
		{
			get
			{
				if (this._dataContext == null)
					this._dataContext = new NorthwindEntityContext(new Uri("http://localhost/Services/Reporting/ProductService.svc/"));
				return this._dataContext;
			}
		}

		public ProductReport()
		{
			InitializeComponent();
			var parameter = this.ReportParameters["Category"];
			parameter.UI.AvailableValues.DataSource = this.DataContext.Categories.ToList();
			parameter.Value = this.DataContext.Categories.ToList<Category>().Select(c => c.CategoryID).ToList<int>();
		}

		private void ProductReport_NeedDataSource(object sender, EventArgs e)
		{
			var categoryIDs = (ArrayList)this.ReportParameters["Category"].Value;
			var productList = new List<Product>();
			for (int i = 0; i < categoryIDs.Count; i++)
			{
				var categoryID = Convert.ToInt32(categoryIDs[i]);
				var products = this.DataContext.Products.Where(p => p.Category.CategoryID == categoryID);
				productList.AddRange(products);
			}
			((Telerik.Reporting.Processing.Report)sender).DataSource = productList;
		}
	}
}